/*
 * Eclat.h
 *
 * Time-stamp: <04/09/04 14:00:19 lars>
 *
 * history: 2004/04/01  1.0  LST created.
 */

#ifndef __ECLAT__
#define __ECLAT__ t

// #include <iostream>
#include "TransactionDatabase.h"
#include "SparseBitmatrix.h"
#include "Timer.h" 
#include <fstream>
#include <stdio.h>
 
// using namespace std;

/**
 * Methods for Eclat algorithm.
 *
 * @author Lars Schmidt-Thieme
 * @version 1.0
 */

int mineAndWritePatterns(TransactionDatabase* trans, int minSup, Timer* timer, FILE* out);
int mineAndWritePatterns(int minSup, FILE* outs, SparseBitmatrix* iti);

SparseBitmatrix* createSparseItemTransactionIncidenceMatrix(TransactionDatabase* tdb);

/**
 * Intersect all rows (with higher index) with a given row. 
 * @param bmIn original bit matrix.
 * @param row row to intersect all other rows (with higher index) with
 * @param bmOut bit matrix to fill intersection into.
 */
int intersectSparseBitmatrix(SparseBitmatrix* bmIn, int row, SparseBitmatrix* bmOut, int minsup);

void rememberEquisupportExtension(int item);

#endif
